searchNodes=[{"doc":"Generate code from an Open API description This task requires two arguments: The configuration profile to use, and The location of the OpenAPI description. The description location can be given as an absolute path or a path relative to the Mix project where this task is run. Example mix api.gen default ../rest-api-description/spec.yaml","ref":"Mix.Tasks.Api.Gen.html","title":"Mix.Tasks.Api.Gen","type":"task"},{"doc":"Code generator for OpenAPI REST API descriptions This module provides a single function, run/2 , that accepts the name of an OpenAPI description file and configuration. It does the work of reading the description, processing schemas and operations, and writing out generated files. For a list of valid options to pass as configuration, see OpenAPI.Config .","ref":"OpenAPI.html","title":"OpenAPI","type":"module"},{"doc":"Read the OpenAPI description at filename and generate code according to config .","ref":"OpenAPI.html#run/2","title":"OpenAPI.run/2","type":"function"},{"doc":"Configuration for the code generator Configuration This section is an overview of the available configuration options. For a more in-depth discussion of output module naming, see Naming below. See also type t:t() below for the exact type specification of each option. base_location (string, required ): Relative path (from the base of the Mix project where the code generator is run) to output files. When creating a standalone client library, this will often be lib/ . base_module (module, required ): Base module for all output files. For example, a base module of Example will output schemas like Example.MySchema and operation files like Example.MyOperations . When outputting a standalone client library, this will often be the base module of the library. default_client (module): Module to call when making a web request. This code generator has no opinion on how HTTP requests are made. Instead, you must provide a client module that implements a request/1 function and performs the request and decodes the response. By default, a module [base_module].Client will be used. group (list of modules): Namespaces to use when grouping modules. For example, two schemas SchemaOne and SchemaTwo grouped by the Schema module would become Schema.One and Schema.Two . Defaults to no grouping. ignore (list of modules, strings, or regular expressions): Schemas to ignore when outputting well-defined Elixir structs. Schemas that are ignored will be replaced with a map type when referenced elsewhere in the code. When provided as a module or string, the ignore pattern must exactly match the name of the schema after any merges . Defaults to no schemas ignored. merge (list of two-tuples): Source and destination modules for schemas that should be merged into a single file. See Merging below for examples. Defaults to no schemas merged. operation_location (string): Relative path, after the base_location , to output operation files. This may useful if you want to hide generated operation files in a subdirectory of a larger project. Defaults to outputting operation files to the base_location . rename (list of rename pattern and action tuples): Renaming actions to take on schema names. The two elements of each tuple will be fed as the second and third arguments to String.replace/4 along with the schema name. See Renaming below for examples. Defaults to no schemas renamed. schema_location (string): Relative path, after the base_location , to output schema files. This may useful if you want to hide generated schema files in a subdirectory of a larger project. Defaults to outputting schema files to the base_location . types (keyword list): Overrides to the types defined by the generator. Each value should be a tuple {module, type} such as {MyModule, :t} . error : Override the error type for all operations. APIs often define their own error schemas, which may differ between operations. Use this option to define a single, consistent error type for all operations. For example, a value {MyError, :t} would cause operations to return {:ok, ...} | {:error, MyError.t()} . Naming Most of the configuration of this project relates to the manipulation of schema names. It is important to understand the order of operations. As an example, imagine an OpenAPI description has the following schemas: #/components/schemas/simple-user #/components/schemas/user #/components/schemas/user-preferences And the following configuration: config :oapi_generator , default : [ base_location : &quot;lib/&quot; , base_module : Example , group : [ User ] , ignore : [ ] , merge : [ { &quot;SimpleUser&quot; , &quot;User&quot; } ] rename : [ { ~r/Preferences/ , &quot;Settings&quot; } ] ] In this case, naming would proceed as follows: Schemas in the OpenAPI descriptions are turned into Elixir modules: #/components/schemas/simple-user =&gt; SimpleUser.t() #/components/schemas/user =&gt; User.t() #/components/schemas/user-preferences =&gt; UserPreferences.t() Merge settings are applied based on the original names of the schemas: SimpleUser . t ( ) =&gt; User . simple ( ) Ignore settings are applied based on the merged module names (no changes in this example). Rename settings are applied based on the merged module names: UserPreferences . t ( ) =&gt; UserSettings . t ( ) Group settings are applied based on the renamed module names: UserSettings . t ( ) =&gt; User.Settings . t ( ) The base module is applied to get the final names: User . simple ( ) =&gt; Example.User . simple ( ) User . t ( ) =&gt; Example.User . t ( ) User.Settings . t ( ) =&gt; Example.User.Settings . t ( ) All of the schemas are then written to appropriate files based on the base_location and schema_location settings. Note that User.simple() and User.t() will end up in the same file as a result of the merge, sharing the same struct for their responses (with distinct typespecs). Merging OpenAPI descriptions may have multiple schemas that are closely related or even duplicated. Merging gives the power to consolidate these schemas into a single struct that is easy to use. For example, the GitHub API description has schemas repository , full-repository , and nullable-repository . While the &quot;full&quot; repository adds additional properties, the &quot;nullable&quot; variant is just that: all of the same properties, but the schema is nullable. This kind of oddity in the OpenAPI specification is exactly what makes most generated code difficult to use. The following merge settings would help clean this up: merge : [ { &quot;FullRepository&quot; , &quot;Repository&quot; } , { ~r/^Nullable/ , &quot;&quot; } ] In the first line, we tell the generator to merge FullRepository into Repository (the original module names based on the names of the schemas). Because the destination module appears at the end of the original module, the word &quot;Repository&quot; will be dropped from the type: FullRepository =&gt; Repository :: Repository . full ( ) This renaming of the type is automatic for prefixes and suffixes. If no overlap is found, then the full (underscored) schema name will be used for the type: SimpleUser =&gt; User :: User . simple ( ) PullRequestSimple =&gt; PullRequest :: PullRequest . simple ( ) MySchema =&gt; Unrelated :: Unrelated . my_schema ( ) If the destination module is later renamed or grouped, the merged schemas will processed in the same way. Collapsing In the second line of the configuration above, we merge two nearly-identical schemas NullableRepository and Repository . Because these schemas have the same fields, there will not be a Repository.nullable() type generated; instead, references will use Repository.t() . Despite this deduplication, other parts of the code will continue to know that the original schema had nullable: true and respond accordingly. Ignoring Sometimes, schemas are best treated as plain maps. In these cases, they can be ignored using a regular expression, exact string, or exact module: ignore : [ ~r/^Unnecessary/ , &quot;SomeSchema&quot; , AnotherSchema ] Any references to an ignored schema will be replaced with a map() type. Grouping Schemas in an OpenAPI description can have extensively long names. For example, GitHub has a schema called actions-cache-usage-by-repository . Along with all other actions-related schemas, we can cut down the top-level module namespace by grouping on Actions or even further: group : [ Actions , Actions.CacheUsage ] Even simple renaming and groups can take a raw OpenAPI description and turn it into a library that feels friendly to users.","ref":"OpenAPI.Config.html","title":"OpenAPI.Config","type":"module"},{"doc":"List of module namespaces to create when grouping","ref":"OpenAPI.Config.html#t:group_options/0","title":"OpenAPI.Config.group_options/0","type":"type"},{"doc":"List of patterns or exact matches of schemas to ignore","ref":"OpenAPI.Config.html#t:ignore_options/0","title":"OpenAPI.Config.ignore_options/0","type":"type"},{"doc":"Patterns or exact matches of schemas to ignore","ref":"OpenAPI.Config.html#t:ignore_pattern/0","title":"OpenAPI.Config.ignore_pattern/0","type":"type"},{"doc":"Before (pattern or exact match) and after (replacement action) for merging schemas by module","ref":"OpenAPI.Config.html#t:merge_options/0","title":"OpenAPI.Config.merge_options/0","type":"type"},{"doc":"Replacement action for renaming schemas by module","ref":"OpenAPI.Config.html#t:rename_action/0","title":"OpenAPI.Config.rename_action/0","type":"type"},{"doc":"List of replacement searches and actions for renaming schemas by module","ref":"OpenAPI.Config.html#t:rename_options/0","title":"OpenAPI.Config.rename_options/0","type":"type"},{"doc":"Search pattern for renaming schemas by module","ref":"OpenAPI.Config.html#t:rename_pattern/0","title":"OpenAPI.Config.rename_pattern/0","type":"type"},{"doc":"Configuration for the code generator","ref":"OpenAPI.Config.html#t:t/0","title":"OpenAPI.Config.t/0","type":"type"},{"doc":"A highly-configurable code generator that combines ergonomics with maintainability. OpenAPI is a standard way to describe REST APIs on the web. Anyone can create an OpenAPI description document that includes the available endpoints, expected request data, and possible responses. For example, GitHub maintains a comprehensive OpenAPI description for their services. Generating code from an OpenAPI description can be relatively easy — this project certainly isn't the first — but there's a catch: API descriptions often don't translate into ergonomic code. Most users of an API client library don't want to think about the difference between a NullableRepository and Repository , as in the OpenAPI 3.0 GitHub API description. (They have the same fields, but one has nullable: true .) Users just want to get back a %Repository{} or nil . The goal of this library is to create ergonomic client libraries from OpenAPI descriptions. At the same time, the changes made to the code are easily repeatable (fully automated) for the sake of maintainability. Think: the friendliness of your favorite hand-crafted client library applied to the scale of large APIs. See an example client library here . For more on how this is accomplished, see Configuration below.","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"This library is available on Hex.pm. Add the dependency in mix.exs : def deps do [ { :oapi_generator , &quot;~&gt; 0.0.4&quot; } ] end Then install the dependency using mix deps.get .","ref":"readme.html#installation","title":"Overview - Installation","type":"extras"},{"doc":"The real power of this library is in the available configuration. Although the options are conceptually simple, they add up to a better user experience. This project uses configuration profiles to allow multiple configurations with the same package. To get started, create a profile called default in your configuration: config :oapi_generator , default : [ base_location : &quot;lib/example&quot; , base_module : Example ] This is the minimum viable configuration for the generator. It will create modules namespaced with Example. and save files in lib/example . For a full list of configuration options, see the documentation for OpenAPI.Config . Output Module Naming When the generator encounters a schema in the OpenAPI description, it performs a number of steps to determine the final name (module and type) of the schema that will be output to a file: Based on the schema's location in the document, a provisional name is assigned. For example, #/components/schemas/full-repository becomes FullRepository.t() . Schemas are merged based on the merge configuration key. For example, you may choose to merge FullRepository.t() into the Repository.t() schema to create Repository.full() . If two merged schemas have identical fields, then they will get the same name. Schemas can be ignored using the ignore configuration key. Ignored schemas will be typed as simple map() types elsewhere in the generated code. Schemas can be renamed using the rename configuration key. For example, you may wish to add or remove a word, change plurality, etc. Finally, schemas can be grouped using the group configuration key. For example, a group of Repository would change RepositoryInvitation to Repository.Invitation . The final module and type will be consistent in the output schema files and other files that reference them. The config/config.exs file for this repository contains an example configuration related to the GitHub API description. It includes a large number of groups for easily readable module names, merges for repeated or highly related schemas, and some module renaming for ease-of-use.","ref":"readme.html#configuration","title":"Overview - Configuration","type":"extras"},{"doc":"Once the library is installed and configured, use mix api.gen with the name of the configuration profile and the OpenAPI description file: mix api.gen default ../rest-api-description/spec.yaml","ref":"readme.html#usage","title":"Overview - Usage","type":"extras"},{"doc":"Code of Conduct Contribution Guidelines License OpenAPI Specification","ref":"readme.html#further-reading","title":"Overview - Further Reading","type":"extras"},{"doc":"If you like this library or it makes you money, please consider sponsoring .","ref":"readme.html#sponsorship","title":"Overview - Sponsorship","type":"extras"},{"doc":"","ref":"code_of_conduct.html","title":"Code of Conduct","type":"extras"},{"doc":"We as members, contributors, and leaders pledge to make participation in our community a harassment-free experience for everyone, regardless of age, body size, visible or invisible disability, ethnicity, sex characteristics, gender identity and expression, level of experience, education, socio-economic status, nationality, personal appearance, race, caste, color, religion, or sexual identity and orientation. We pledge to act and interact in ways that contribute to an open, welcoming, diverse, inclusive, and healthy community.","ref":"code_of_conduct.html#our-pledge","title":"Code of Conduct - Our Pledge","type":"extras"},{"doc":"Examples of behavior that contributes to a positive environment for our community include: Demonstrating empathy and kindness toward other people Being respectful of differing opinions, viewpoints, and experiences Giving and gracefully accepting constructive feedback Accepting responsibility and apologizing to those affected by our mistakes, and learning from the experience Focusing on what is best not just for us as individuals, but for the overall community Examples of unacceptable behavior include: The use of sexualized language or imagery, and sexual attention or advances of any kind Trolling, insulting or derogatory comments, and personal or political attacks Public or private harassment Publishing others' private information, such as a physical or email address, without their explicit permission Other conduct which could reasonably be considered inappropriate in a professional setting","ref":"code_of_conduct.html#our-standards","title":"Code of Conduct - Our Standards","type":"extras"},{"doc":"Community leaders are responsible for clarifying and enforcing our standards of acceptable behavior and will take appropriate and fair corrective action in response to any behavior that they deem inappropriate, threatening, offensive, or harmful. Community leaders have the right and responsibility to remove, edit, or reject comments, commits, code, wiki edits, issues, and other contributions that are not aligned to this Code of Conduct, and will communicate reasons for moderation decisions when appropriate.","ref":"code_of_conduct.html#enforcement-responsibilities","title":"Code of Conduct - Enforcement Responsibilities","type":"extras"},{"doc":"This Code of Conduct applies within all community spaces, and also applies when an individual is officially representing the community in public spaces. Examples of representing our community include using an official e-mail address, posting via an official social media account, or acting as an appointed representative at an online or offline event.","ref":"code_of_conduct.html#scope","title":"Code of Conduct - Scope","type":"extras"},{"doc":"Instances of abusive, harassing, or otherwise unacceptable behavior may be reported to the community leaders responsible for enforcement by email . All complaints will be reviewed and investigated promptly and fairly. All community leaders are obligated to respect the privacy and security of the reporter of any incident.","ref":"code_of_conduct.html#enforcement","title":"Code of Conduct - Enforcement","type":"extras"},{"doc":"Community leaders will follow these Community Impact Guidelines in determining the consequences for any action they deem in violation of this Code of Conduct: 1. Correction Community Impact : Use of inappropriate language or other behavior deemed unprofessional or unwelcome in the community. Consequence : A private, written warning from community leaders, providing clarity around the nature of the violation and an explanation of why the behavior was inappropriate. A public apology may be requested. 2. Warning Community Impact : A violation through a single incident or series of actions. Consequence : A warning with consequences for continued behavior. No interaction with the people involved, including unsolicited interaction with those enforcing the Code of Conduct, for a specified period of time. This includes avoiding interactions in community spaces as well as external channels like social media. Violating these terms may lead to a temporary or permanent ban. 3. Temporary Ban Community Impact : A serious violation of community standards, including sustained inappropriate behavior. Consequence : A temporary ban from any sort of interaction or public communication with the community for a specified period of time. No public or private interaction with the people involved, including unsolicited interaction with those enforcing the Code of Conduct, is allowed during this period. Violating these terms may lead to a permanent ban. 4. Permanent Ban Community Impact : Demonstrating a pattern of violation of community standards, including sustained inappropriate behavior, harassment of an individual, or aggression toward or disparagement of classes of individuals. Consequence : A permanent ban from any sort of public interaction within the community.","ref":"code_of_conduct.html#enforcement-guidelines","title":"Code of Conduct - Enforcement Guidelines","type":"extras"},{"doc":"This Code of Conduct is adapted from the Contributor Covenant , version 2.1, available at https://www.contributor-covenant.org/version/2/1/code_of_conduct.html . Community Impact Guidelines were inspired by Mozilla's code of conduct enforcement ladder . For answers to common questions about this code of conduct, see the FAQ at https://www.contributor-covenant.org/faq . Translations are available at https://www.contributor-covenant.org/translations .","ref":"code_of_conduct.html#attribution","title":"Code of Conduct - Attribution","type":"extras"},{"doc":"Hello there. Thank you for your interest in contributing to this project. With a wide variety of OpenAPI descriptions in the world, this project could use your assistance. Reading and following the guidelines in this document is an act of kindness and respect for other contributors. With your help, we can address issues, make changes, and work together efficiently.","ref":"contributing.html","title":"Contributing","type":"extras"},{"doc":"There are many ways to contribute to this project: Individuals with experience in Elixir can help us to address observed and potential issues. Users of REST APIs with OpenAPI descriptions can try the generator and report any issues or recommendations for improvement they encounter. Users of the package can help to test new use-cases and patterns. Documentation improves everyone's experience. Anyone can assist in the triage of bugs, identifying root causes, and proposing solutions. Please keep in mind the intended scope of this package: to provide a code generator that balances an ergonomic user experience with maintainability. Assume that the OpenAPI description that serves as input to this library will change often, and manually changing the output is impractical.","ref":"contributing.html#ways-to-contribute","title":"Contributing - Ways to Contribute","type":"extras"},{"doc":"All contributions to this project must align with the code of conduct . Beyond that, we ask: Please be kind. Maintaining this project is not paid work. Please create an issue before embarking on major refactors or new features. Let's make reasonable effort to support as many OpenAPI descriptions as possible.","ref":"contributing.html#ground-rules","title":"Contributing - Ground Rules","type":"extras"},{"doc":"If you find a security-related issue with this project, please refrain from opening a public issue and instead email the maintainer .","ref":"contributing.html#security-issues","title":"Contributing - Security Issues","type":"extras"},{"doc":"MIT License Copyright (c) 2022 AJ Foster Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"License","type":"extras"}]